import {Player} from "./player.js"
import {roomManager} from "./roomManager.js"
import { World} from "./world/world.js"

export class Game {
  id: string;
  players: Player[];
  world: World;
  constructor(id:string, options:any) {
    this.id = id;
    this.players = [];
    this.world = new World(options)
  }

  addPlayer(id:string, name:string, color:number):Player {
    // if (this.getAllNames().includes(name)) return false
    const player = new Player(id, name, color);
    this.players.push(player);
    return player
  }

  removePlayerByID(id:string) {
    this.players = this.players.filter(obj => obj.id != id);
    if (this.players.length < 1) {
      roomManager.removeGameByID(this.id);
    }
  }

  getAllIDs():string[] {
    let ids = []
    for (let i = 0; i < this.players.length; i++) {
      ids.push(this.players[i].id)
    }
    return ids
  }
  getAllNames():string[] {
    let names = []
    for (let i = 0; i < this.players.length; i++) {
      names.push(this.players[i].name)
    }
    return names
  }
}
